<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>SessionInputBufferImpl xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../apidocs/org/apache/http/impl/nio/reactor/SessionInputBufferImpl.html">View Javadoc</a></div><pre>

<a class="jxr_linenumber" name="1" href="#1">1</a>   <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="2" href="#2">2</a>   <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="3" href="#3">3</a>   <em class="jxr_comment"> * Licensed to the Apache Software Foundation (ASF) under one</em>
<a class="jxr_linenumber" name="4" href="#4">4</a>   <em class="jxr_comment"> * or more contributor license agreements.  See the NOTICE file</em>
<a class="jxr_linenumber" name="5" href="#5">5</a>   <em class="jxr_comment"> * distributed with this work for additional information</em>
<a class="jxr_linenumber" name="6" href="#6">6</a>   <em class="jxr_comment"> * regarding copyright ownership.  The ASF licenses this file</em>
<a class="jxr_linenumber" name="7" href="#7">7</a>   <em class="jxr_comment"> * to you under the Apache License, Version 2.0 (the</em>
<a class="jxr_linenumber" name="8" href="#8">8</a>   <em class="jxr_comment"> * "License"); you may not use this file except in compliance</em>
<a class="jxr_linenumber" name="9" href="#9">9</a>   <em class="jxr_comment"> * with the License.  You may obtain a copy of the License at</em>
<a class="jxr_linenumber" name="10" href="#10">10</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="11" href="#11">11</a>  <em class="jxr_comment"> *   <a href="http://www.apache.org/licenses/LICENSE-2.0" target="alexandria_uri">http://www.apache.org/licenses/LICENSE-2.0</a></em>
<a class="jxr_linenumber" name="12" href="#12">12</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="13" href="#13">13</a>  <em class="jxr_comment"> * Unless required by applicable law or agreed to in writing,</em>
<a class="jxr_linenumber" name="14" href="#14">14</a>  <em class="jxr_comment"> * software distributed under the License is distributed on an</em>
<a class="jxr_linenumber" name="15" href="#15">15</a>  <em class="jxr_comment"> * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY</em>
<a class="jxr_linenumber" name="16" href="#16">16</a>  <em class="jxr_comment"> * KIND, either express or implied.  See the License for the</em>
<a class="jxr_linenumber" name="17" href="#17">17</a>  <em class="jxr_comment"> * specific language governing permissions and limitations</em>
<a class="jxr_linenumber" name="18" href="#18">18</a>  <em class="jxr_comment"> * under the License.</em>
<a class="jxr_linenumber" name="19" href="#19">19</a>  <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="20" href="#20">20</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="21" href="#21">21</a>  <em class="jxr_comment"> * This software consists of voluntary contributions made by many</em>
<a class="jxr_linenumber" name="22" href="#22">22</a>  <em class="jxr_comment"> * individuals on behalf of the Apache Software Foundation.  For more</em>
<a class="jxr_linenumber" name="23" href="#23">23</a>  <em class="jxr_comment"> * information on the Apache Software Foundation, please see</em>
<a class="jxr_linenumber" name="24" href="#24">24</a>  <em class="jxr_comment"> * &lt;<a href="http://www.apache.org/&gt;." target="alexandria_uri">http://www.apache.org/&gt;.</a></em>
<a class="jxr_linenumber" name="25" href="#25">25</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="26" href="#26">26</a>  <em class="jxr_comment"> */</em>
<a class="jxr_linenumber" name="27" href="#27">27</a>  
<a class="jxr_linenumber" name="28" href="#28">28</a>  <strong class="jxr_keyword">package</strong> org.apache.http.impl.nio.reactor;
<a class="jxr_linenumber" name="29" href="#29">29</a>  
<a class="jxr_linenumber" name="30" href="#30">30</a>  <strong class="jxr_keyword">import</strong> java.io.IOException;
<a class="jxr_linenumber" name="31" href="#31">31</a>  <strong class="jxr_keyword">import</strong> java.nio.ByteBuffer;
<a class="jxr_linenumber" name="32" href="#32">32</a>  <strong class="jxr_keyword">import</strong> java.nio.CharBuffer;
<a class="jxr_linenumber" name="33" href="#33">33</a>  <strong class="jxr_keyword">import</strong> java.nio.channels.ReadableByteChannel;
<a class="jxr_linenumber" name="34" href="#34">34</a>  <strong class="jxr_keyword">import</strong> java.nio.channels.WritableByteChannel;
<a class="jxr_linenumber" name="35" href="#35">35</a>  <strong class="jxr_keyword">import</strong> java.nio.charset.CharacterCodingException;
<a class="jxr_linenumber" name="36" href="#36">36</a>  <strong class="jxr_keyword">import</strong> java.nio.charset.Charset;
<a class="jxr_linenumber" name="37" href="#37">37</a>  <strong class="jxr_keyword">import</strong> java.nio.charset.CharsetDecoder;
<a class="jxr_linenumber" name="38" href="#38">38</a>  <strong class="jxr_keyword">import</strong> java.nio.charset.CoderResult;
<a class="jxr_linenumber" name="39" href="#39">39</a>  <strong class="jxr_keyword">import</strong> java.nio.charset.CodingErrorAction;
<a class="jxr_linenumber" name="40" href="#40">40</a>  
<a class="jxr_linenumber" name="41" href="#41">41</a>  <strong class="jxr_keyword">import</strong> org.apache.http.annotation.NotThreadSafe;
<a class="jxr_linenumber" name="42" href="#42">42</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.reactor.SessionInputBuffer;
<a class="jxr_linenumber" name="43" href="#43">43</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.util.ByteBufferAllocator;
<a class="jxr_linenumber" name="44" href="#44">44</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.util.ExpandableBuffer;
<a class="jxr_linenumber" name="45" href="#45">45</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.util.HeapByteBufferAllocator;
<a class="jxr_linenumber" name="46" href="#46">46</a>  <strong class="jxr_keyword">import</strong> org.apache.http.params.CoreProtocolPNames;
<a class="jxr_linenumber" name="47" href="#47">47</a>  <strong class="jxr_keyword">import</strong> org.apache.http.params.HttpParams;
<a class="jxr_linenumber" name="48" href="#48">48</a>  <strong class="jxr_keyword">import</strong> org.apache.http.protocol.HTTP;
<a class="jxr_linenumber" name="49" href="#49">49</a>  <strong class="jxr_keyword">import</strong> org.apache.http.util.Args;
<a class="jxr_linenumber" name="50" href="#50">50</a>  <strong class="jxr_keyword">import</strong> org.apache.http.util.CharArrayBuffer;
<a class="jxr_linenumber" name="51" href="#51">51</a>  <strong class="jxr_keyword">import</strong> org.apache.http.util.CharsetUtils;
<a class="jxr_linenumber" name="52" href="#52">52</a>  
<a class="jxr_linenumber" name="53" href="#53">53</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="54" href="#54">54</a>  <em class="jxr_javadoccomment"> * Default implementation of {@link SessionInputBuffer} based on</em>
<a class="jxr_linenumber" name="55" href="#55">55</a>  <em class="jxr_javadoccomment"> * the {@link ExpandableBuffer} class.</em>
<a class="jxr_linenumber" name="56" href="#56">56</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="57" href="#57">57</a>  <em class="jxr_javadoccomment"> * @since 4.0</em>
<a class="jxr_linenumber" name="58" href="#58">58</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="59" href="#59">59</a>  @SuppressWarnings(<span class="jxr_string">"deprecation"</span>)
<a class="jxr_linenumber" name="60" href="#60">60</a>  @NotThreadSafe
<a class="jxr_linenumber" name="61" href="#61">61</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../org/apache/http/impl/nio/reactor/SessionInputBufferImpl.html">SessionInputBufferImpl</a> <strong class="jxr_keyword">extends</strong> <a href="../../../../../../org/apache/http/nio/util/ExpandableBuffer.html">ExpandableBuffer</a> <strong class="jxr_keyword">implements</strong> <a href="../../../../../../org/apache/http/nio/reactor/SessionInputBuffer.html">SessionInputBuffer</a> {
<a class="jxr_linenumber" name="62" href="#62">62</a>  
<a class="jxr_linenumber" name="63" href="#63">63</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">final</strong> CharsetDecoder chardecoder;
<a class="jxr_linenumber" name="64" href="#64">64</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">int</strong> lineBuffersize;
<a class="jxr_linenumber" name="65" href="#65">65</a>  
<a class="jxr_linenumber" name="66" href="#66">66</a>      <strong class="jxr_keyword">private</strong> CharBuffer charbuffer;
<a class="jxr_linenumber" name="67" href="#67">67</a>  
<a class="jxr_linenumber" name="68" href="#68">68</a>      <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="69" href="#69">69</a>  <em class="jxr_javadoccomment">     *  Creates SessionInputBufferImpl instance.</em>
<a class="jxr_linenumber" name="70" href="#70">70</a>  <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="71" href="#71">71</a>  <em class="jxr_javadoccomment">     * @param buffersize input buffer size</em>
<a class="jxr_linenumber" name="72" href="#72">72</a>  <em class="jxr_javadoccomment">     * @param lineBuffersize buffer size for line operations. Has effect only if</em>
<a class="jxr_linenumber" name="73" href="#73">73</a>  <em class="jxr_javadoccomment">     *   &lt;code&gt;chardecoder&lt;/code&gt; is not &lt;code&gt;null&lt;/code&gt;.</em>
<a class="jxr_linenumber" name="74" href="#74">74</a>  <em class="jxr_javadoccomment">     * @param chardecoder chardecoder to be used for decoding HTTP protocol elements.</em>
<a class="jxr_linenumber" name="75" href="#75">75</a>  <em class="jxr_javadoccomment">     *   If &lt;code&gt;null&lt;/code&gt; simple type cast will be used for byte to char conversion.</em>
<a class="jxr_linenumber" name="76" href="#76">76</a>  <em class="jxr_javadoccomment">     * @param allocator memory allocator.</em>
<a class="jxr_linenumber" name="77" href="#77">77</a>  <em class="jxr_javadoccomment">     *   If &lt;code&gt;null&lt;/code&gt; {@link HeapByteBufferAllocator#INSTANCE} will be used.</em>
<a class="jxr_linenumber" name="78" href="#78">78</a>  <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="79" href="#79">79</a>  <em class="jxr_javadoccomment">     * @since 4.3</em>
<a class="jxr_linenumber" name="80" href="#80">80</a>  <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="81" href="#81">81</a>      <strong class="jxr_keyword">public</strong> <a href="../../../../../../org/apache/http/impl/nio/reactor/SessionInputBufferImpl.html">SessionInputBufferImpl</a>(
<a class="jxr_linenumber" name="82" href="#82">82</a>              <strong class="jxr_keyword">int</strong> buffersize,
<a class="jxr_linenumber" name="83" href="#83">83</a>              <strong class="jxr_keyword">int</strong> lineBuffersize,
<a class="jxr_linenumber" name="84" href="#84">84</a>              <strong class="jxr_keyword">final</strong> CharsetDecoder chardecoder,
<a class="jxr_linenumber" name="85" href="#85">85</a>              <strong class="jxr_keyword">final</strong> <a href="../../../../../../org/apache/http/nio/util/ByteBufferAllocator.html">ByteBufferAllocator</a> allocator) {
<a class="jxr_linenumber" name="86" href="#86">86</a>          <strong class="jxr_keyword">super</strong>(buffersize, allocator != <strong class="jxr_keyword">null</strong> ? allocator : HeapByteBufferAllocator.INSTANCE);
<a class="jxr_linenumber" name="87" href="#87">87</a>          <strong class="jxr_keyword">this</strong>.lineBuffersize = Args.positive(lineBuffersize, <span class="jxr_string">"Line buffer size"</span>);
<a class="jxr_linenumber" name="88" href="#88">88</a>          <strong class="jxr_keyword">this</strong>.chardecoder = chardecoder;
<a class="jxr_linenumber" name="89" href="#89">89</a>      }
<a class="jxr_linenumber" name="90" href="#90">90</a>  
<a class="jxr_linenumber" name="91" href="#91">91</a>      <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="92" href="#92">92</a>  <em class="jxr_javadoccomment">     * @deprecated (4.3) use</em>
<a class="jxr_linenumber" name="93" href="#93">93</a>  <em class="jxr_javadoccomment">     *   {@link SessionInputBufferImpl#SessionInputBufferImpl(int, int, CharsetDecoder,</em>
<a class="jxr_linenumber" name="94" href="#94">94</a>  <em class="jxr_javadoccomment">     *     ByteBufferAllocator)}</em>
<a class="jxr_linenumber" name="95" href="#95">95</a>  <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="96" href="#96">96</a>      @Deprecated
<a class="jxr_linenumber" name="97" href="#97">97</a>      <strong class="jxr_keyword">public</strong> <a href="../../../../../../org/apache/http/impl/nio/reactor/SessionInputBufferImpl.html">SessionInputBufferImpl</a>(
<a class="jxr_linenumber" name="98" href="#98">98</a>              <strong class="jxr_keyword">int</strong> buffersize,
<a class="jxr_linenumber" name="99" href="#99">99</a>              <strong class="jxr_keyword">int</strong> lineBuffersize,
<a class="jxr_linenumber" name="100" href="#100">100</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../../../org/apache/http/nio/util/ByteBufferAllocator.html">ByteBufferAllocator</a> allocator,
<a class="jxr_linenumber" name="101" href="#101">101</a>             <strong class="jxr_keyword">final</strong> HttpParams params) {
<a class="jxr_linenumber" name="102" href="#102">102</a>         <strong class="jxr_keyword">super</strong>(buffersize, allocator);
<a class="jxr_linenumber" name="103" href="#103">103</a>         <strong class="jxr_keyword">this</strong>.lineBuffersize = Args.positive(lineBuffersize, <span class="jxr_string">"Line buffer size"</span>);
<a class="jxr_linenumber" name="104" href="#104">104</a>         String charsetName = (String) params.getParameter(CoreProtocolPNames.HTTP_ELEMENT_CHARSET);
<a class="jxr_linenumber" name="105" href="#105">105</a>         Charset charset = CharsetUtils.lookup(charsetName);
<a class="jxr_linenumber" name="106" href="#106">106</a>         <strong class="jxr_keyword">if</strong> (charset != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="107" href="#107">107</a>             <strong class="jxr_keyword">this</strong>.chardecoder = charset.newDecoder();
<a class="jxr_linenumber" name="108" href="#108">108</a>             CodingErrorAction a1 = (CodingErrorAction) params.getParameter(
<a class="jxr_linenumber" name="109" href="#109">109</a>                     CoreProtocolPNames.HTTP_MALFORMED_INPUT_ACTION);
<a class="jxr_linenumber" name="110" href="#110">110</a>             <strong class="jxr_keyword">this</strong>.chardecoder.onMalformedInput(a1 != <strong class="jxr_keyword">null</strong> ? a1 : CodingErrorAction.REPORT);
<a class="jxr_linenumber" name="111" href="#111">111</a>             CodingErrorAction a2 = (CodingErrorAction) params.getParameter(
<a class="jxr_linenumber" name="112" href="#112">112</a>                     CoreProtocolPNames.HTTP_UNMAPPABLE_INPUT_ACTION);
<a class="jxr_linenumber" name="113" href="#113">113</a>             <strong class="jxr_keyword">this</strong>.chardecoder.onUnmappableCharacter(a2 != <strong class="jxr_keyword">null</strong>? a2 : CodingErrorAction.REPORT);
<a class="jxr_linenumber" name="114" href="#114">114</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="115" href="#115">115</a>             <strong class="jxr_keyword">this</strong>.chardecoder = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="116" href="#116">116</a>         }
<a class="jxr_linenumber" name="117" href="#117">117</a>     }
<a class="jxr_linenumber" name="118" href="#118">118</a> 
<a class="jxr_linenumber" name="119" href="#119">119</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="120" href="#120">120</a> <em class="jxr_javadoccomment">     * @deprecated (4.3) use</em>
<a class="jxr_linenumber" name="121" href="#121">121</a> <em class="jxr_javadoccomment">     *   {@link SessionInputBufferImpl#SessionInputBufferImpl(int, int, Charset)}</em>
<a class="jxr_linenumber" name="122" href="#122">122</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="123" href="#123">123</a>     @Deprecated
<a class="jxr_linenumber" name="124" href="#124">124</a>     <strong class="jxr_keyword">public</strong> <a href="../../../../../../org/apache/http/impl/nio/reactor/SessionInputBufferImpl.html">SessionInputBufferImpl</a>(
<a class="jxr_linenumber" name="125" href="#125">125</a>             <strong class="jxr_keyword">int</strong> buffersize,
<a class="jxr_linenumber" name="126" href="#126">126</a>             <strong class="jxr_keyword">int</strong> linebuffersize,
<a class="jxr_linenumber" name="127" href="#127">127</a>             <strong class="jxr_keyword">final</strong> HttpParams params) {
<a class="jxr_linenumber" name="128" href="#128">128</a>         <strong class="jxr_keyword">this</strong>(buffersize, linebuffersize, HeapByteBufferAllocator.INSTANCE, params);
<a class="jxr_linenumber" name="129" href="#129">129</a>     }
<a class="jxr_linenumber" name="130" href="#130">130</a> 
<a class="jxr_linenumber" name="131" href="#131">131</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="132" href="#132">132</a> <em class="jxr_javadoccomment">     * @since 4.3</em>
<a class="jxr_linenumber" name="133" href="#133">133</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="134" href="#134">134</a>     <strong class="jxr_keyword">public</strong> <a href="../../../../../../org/apache/http/impl/nio/reactor/SessionInputBufferImpl.html">SessionInputBufferImpl</a>(<strong class="jxr_keyword">int</strong> buffersize) {
<a class="jxr_linenumber" name="135" href="#135">135</a>         <strong class="jxr_keyword">this</strong>(buffersize, 256, <strong class="jxr_keyword">null</strong>, HeapByteBufferAllocator.INSTANCE);
<a class="jxr_linenumber" name="136" href="#136">136</a>     }
<a class="jxr_linenumber" name="137" href="#137">137</a> 
<a class="jxr_linenumber" name="138" href="#138">138</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="139" href="#139">139</a> <em class="jxr_javadoccomment">     * @since 4.3</em>
<a class="jxr_linenumber" name="140" href="#140">140</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="141" href="#141">141</a>     <strong class="jxr_keyword">public</strong> <a href="../../../../../../org/apache/http/impl/nio/reactor/SessionInputBufferImpl.html">SessionInputBufferImpl</a>(
<a class="jxr_linenumber" name="142" href="#142">142</a>             <strong class="jxr_keyword">int</strong> buffersize,
<a class="jxr_linenumber" name="143" href="#143">143</a>             <strong class="jxr_keyword">int</strong> lineBuffersize,
<a class="jxr_linenumber" name="144" href="#144">144</a>             <strong class="jxr_keyword">final</strong> Charset charset) {
<a class="jxr_linenumber" name="145" href="#145">145</a>         <strong class="jxr_keyword">this</strong>(buffersize, lineBuffersize,
<a class="jxr_linenumber" name="146" href="#146">146</a>                 charset != <strong class="jxr_keyword">null</strong> ? charset.newDecoder() : <strong class="jxr_keyword">null</strong>, HeapByteBufferAllocator.INSTANCE);
<a class="jxr_linenumber" name="147" href="#147">147</a>     }
<a class="jxr_linenumber" name="148" href="#148">148</a> 
<a class="jxr_linenumber" name="149" href="#149">149</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">int</strong> fill(<strong class="jxr_keyword">final</strong> ReadableByteChannel channel) <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="150" href="#150">150</a>         Args.notNull(channel, <span class="jxr_string">"Channel"</span>);
<a class="jxr_linenumber" name="151" href="#151">151</a>         setInputMode();
<a class="jxr_linenumber" name="152" href="#152">152</a>         <strong class="jxr_keyword">if</strong> (!<strong class="jxr_keyword">this</strong>.buffer.hasRemaining()) {
<a class="jxr_linenumber" name="153" href="#153">153</a>             expand();
<a class="jxr_linenumber" name="154" href="#154">154</a>         }
<a class="jxr_linenumber" name="155" href="#155">155</a>         <strong class="jxr_keyword">int</strong> readNo = channel.read(<strong class="jxr_keyword">this</strong>.buffer);
<a class="jxr_linenumber" name="156" href="#156">156</a>         <strong class="jxr_keyword">return</strong> readNo;
<a class="jxr_linenumber" name="157" href="#157">157</a>     }
<a class="jxr_linenumber" name="158" href="#158">158</a> 
<a class="jxr_linenumber" name="159" href="#159">159</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">int</strong> read() {
<a class="jxr_linenumber" name="160" href="#160">160</a>         setOutputMode();
<a class="jxr_linenumber" name="161" href="#161">161</a>         <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">this</strong>.buffer.get() &amp; 0xff;
<a class="jxr_linenumber" name="162" href="#162">162</a>     }
<a class="jxr_linenumber" name="163" href="#163">163</a> 
<a class="jxr_linenumber" name="164" href="#164">164</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">int</strong> read(<strong class="jxr_keyword">final</strong> ByteBuffer dst, <strong class="jxr_keyword">int</strong> maxLen) {
<a class="jxr_linenumber" name="165" href="#165">165</a>         <strong class="jxr_keyword">if</strong> (dst == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="166" href="#166">166</a>             <strong class="jxr_keyword">return</strong> 0;
<a class="jxr_linenumber" name="167" href="#167">167</a>         }
<a class="jxr_linenumber" name="168" href="#168">168</a>         setOutputMode();
<a class="jxr_linenumber" name="169" href="#169">169</a>         <strong class="jxr_keyword">int</strong> len = Math.min(dst.remaining(), maxLen);
<a class="jxr_linenumber" name="170" href="#170">170</a>         <strong class="jxr_keyword">int</strong> chunk = Math.min(<strong class="jxr_keyword">this</strong>.buffer.remaining(), len);
<a class="jxr_linenumber" name="171" href="#171">171</a>         <strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i = 0; i &lt; chunk; i++) {
<a class="jxr_linenumber" name="172" href="#172">172</a>             dst.put(<strong class="jxr_keyword">this</strong>.buffer.get());
<a class="jxr_linenumber" name="173" href="#173">173</a>         }
<a class="jxr_linenumber" name="174" href="#174">174</a>         <strong class="jxr_keyword">return</strong> chunk;
<a class="jxr_linenumber" name="175" href="#175">175</a>     }
<a class="jxr_linenumber" name="176" href="#176">176</a> 
<a class="jxr_linenumber" name="177" href="#177">177</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">int</strong> read(<strong class="jxr_keyword">final</strong> ByteBuffer dst) {
<a class="jxr_linenumber" name="178" href="#178">178</a>         <strong class="jxr_keyword">if</strong> (dst == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="179" href="#179">179</a>             <strong class="jxr_keyword">return</strong> 0;
<a class="jxr_linenumber" name="180" href="#180">180</a>         }
<a class="jxr_linenumber" name="181" href="#181">181</a>         <strong class="jxr_keyword">return</strong> read(dst, dst.remaining());
<a class="jxr_linenumber" name="182" href="#182">182</a>     }
<a class="jxr_linenumber" name="183" href="#183">183</a> 
<a class="jxr_linenumber" name="184" href="#184">184</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">int</strong> read(<strong class="jxr_keyword">final</strong> WritableByteChannel dst, <strong class="jxr_keyword">int</strong> maxLen) <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="185" href="#185">185</a>         <strong class="jxr_keyword">if</strong> (dst == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="186" href="#186">186</a>             <strong class="jxr_keyword">return</strong> 0;
<a class="jxr_linenumber" name="187" href="#187">187</a>         }
<a class="jxr_linenumber" name="188" href="#188">188</a>         setOutputMode();
<a class="jxr_linenumber" name="189" href="#189">189</a>         <strong class="jxr_keyword">int</strong> bytesRead;
<a class="jxr_linenumber" name="190" href="#190">190</a>         <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.buffer.remaining() &gt; maxLen) {
<a class="jxr_linenumber" name="191" href="#191">191</a>             <strong class="jxr_keyword">int</strong> oldLimit = <strong class="jxr_keyword">this</strong>.buffer.limit();
<a class="jxr_linenumber" name="192" href="#192">192</a>             <strong class="jxr_keyword">int</strong> newLimit = oldLimit - (<strong class="jxr_keyword">this</strong>.buffer.remaining() - maxLen);
<a class="jxr_linenumber" name="193" href="#193">193</a>             <strong class="jxr_keyword">this</strong>.buffer.limit(newLimit);
<a class="jxr_linenumber" name="194" href="#194">194</a>             bytesRead = dst.write(<strong class="jxr_keyword">this</strong>.buffer);
<a class="jxr_linenumber" name="195" href="#195">195</a>             <strong class="jxr_keyword">this</strong>.buffer.limit(oldLimit);
<a class="jxr_linenumber" name="196" href="#196">196</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="197" href="#197">197</a>             bytesRead = dst.write(<strong class="jxr_keyword">this</strong>.buffer);
<a class="jxr_linenumber" name="198" href="#198">198</a>         }
<a class="jxr_linenumber" name="199" href="#199">199</a>         <strong class="jxr_keyword">return</strong> bytesRead;
<a class="jxr_linenumber" name="200" href="#200">200</a>     }
<a class="jxr_linenumber" name="201" href="#201">201</a> 
<a class="jxr_linenumber" name="202" href="#202">202</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">int</strong> read(<strong class="jxr_keyword">final</strong> WritableByteChannel dst) <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="203" href="#203">203</a>         <strong class="jxr_keyword">if</strong> (dst == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="204" href="#204">204</a>             <strong class="jxr_keyword">return</strong> 0;
<a class="jxr_linenumber" name="205" href="#205">205</a>         }
<a class="jxr_linenumber" name="206" href="#206">206</a>         setOutputMode();
<a class="jxr_linenumber" name="207" href="#207">207</a>         <strong class="jxr_keyword">return</strong> dst.write(<strong class="jxr_keyword">this</strong>.buffer);
<a class="jxr_linenumber" name="208" href="#208">208</a>     }
<a class="jxr_linenumber" name="209" href="#209">209</a> 
<a class="jxr_linenumber" name="210" href="#210">210</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">boolean</strong> readLine(
<a class="jxr_linenumber" name="211" href="#211">211</a>             <strong class="jxr_keyword">final</strong> CharArrayBuffer linebuffer,
<a class="jxr_linenumber" name="212" href="#212">212</a>             <strong class="jxr_keyword">boolean</strong> endOfStream) <strong class="jxr_keyword">throws</strong> CharacterCodingException {
<a class="jxr_linenumber" name="213" href="#213">213</a> 
<a class="jxr_linenumber" name="214" href="#214">214</a>         setOutputMode();
<a class="jxr_linenumber" name="215" href="#215">215</a>         <em class="jxr_comment">// See if there is LF char present in the buffer</em>
<a class="jxr_linenumber" name="216" href="#216">216</a>         <strong class="jxr_keyword">int</strong> pos = -1;
<a class="jxr_linenumber" name="217" href="#217">217</a>         <strong class="jxr_keyword">boolean</strong> hasLine = false;
<a class="jxr_linenumber" name="218" href="#218">218</a>         <strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i = <strong class="jxr_keyword">this</strong>.buffer.position(); i &lt; <strong class="jxr_keyword">this</strong>.buffer.limit(); i++) {
<a class="jxr_linenumber" name="219" href="#219">219</a>             <strong class="jxr_keyword">int</strong> b = <strong class="jxr_keyword">this</strong>.buffer.get(i);
<a class="jxr_linenumber" name="220" href="#220">220</a>             <strong class="jxr_keyword">if</strong> (b == HTTP.LF) {
<a class="jxr_linenumber" name="221" href="#221">221</a>                 hasLine = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="222" href="#222">222</a>                 pos = i + 1;
<a class="jxr_linenumber" name="223" href="#223">223</a>                 <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="224" href="#224">224</a>             }
<a class="jxr_linenumber" name="225" href="#225">225</a>         }
<a class="jxr_linenumber" name="226" href="#226">226</a>         <strong class="jxr_keyword">if</strong> (!hasLine) {
<a class="jxr_linenumber" name="227" href="#227">227</a>             <strong class="jxr_keyword">if</strong> (endOfStream &amp;&amp; <strong class="jxr_keyword">this</strong>.buffer.hasRemaining()) {
<a class="jxr_linenumber" name="228" href="#228">228</a>                 <em class="jxr_comment">// No more data. Get the rest</em>
<a class="jxr_linenumber" name="229" href="#229">229</a>                 pos = <strong class="jxr_keyword">this</strong>.buffer.limit();
<a class="jxr_linenumber" name="230" href="#230">230</a>             } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="231" href="#231">231</a>                 <em class="jxr_comment">// Either no complete line present in the buffer</em>
<a class="jxr_linenumber" name="232" href="#232">232</a>                 <em class="jxr_comment">// or no more data is expected</em>
<a class="jxr_linenumber" name="233" href="#233">233</a>                 <strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="234" href="#234">234</a>             }
<a class="jxr_linenumber" name="235" href="#235">235</a>         }
<a class="jxr_linenumber" name="236" href="#236">236</a>         <strong class="jxr_keyword">int</strong> origLimit = <strong class="jxr_keyword">this</strong>.buffer.limit();
<a class="jxr_linenumber" name="237" href="#237">237</a>         <strong class="jxr_keyword">this</strong>.buffer.limit(pos);
<a class="jxr_linenumber" name="238" href="#238">238</a> 
<a class="jxr_linenumber" name="239" href="#239">239</a>         <strong class="jxr_keyword">int</strong> requiredCapacity = <strong class="jxr_keyword">this</strong>.buffer.limit() - <strong class="jxr_keyword">this</strong>.buffer.position();
<a class="jxr_linenumber" name="240" href="#240">240</a>         <em class="jxr_comment">// Ensure capacity of len assuming ASCII as the most likely charset</em>
<a class="jxr_linenumber" name="241" href="#241">241</a>         linebuffer.ensureCapacity(requiredCapacity);
<a class="jxr_linenumber" name="242" href="#242">242</a> 
<a class="jxr_linenumber" name="243" href="#243">243</a>         <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.chardecoder == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="244" href="#244">244</a>             <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.buffer.hasArray()) {
<a class="jxr_linenumber" name="245" href="#245">245</a>                 byte[] b = <strong class="jxr_keyword">this</strong>.buffer.array();
<a class="jxr_linenumber" name="246" href="#246">246</a>                 <strong class="jxr_keyword">int</strong> off = <strong class="jxr_keyword">this</strong>.buffer.position();
<a class="jxr_linenumber" name="247" href="#247">247</a>                 <strong class="jxr_keyword">int</strong> len = <strong class="jxr_keyword">this</strong>.buffer.remaining();
<a class="jxr_linenumber" name="248" href="#248">248</a>                 linebuffer.append(b, off, len);
<a class="jxr_linenumber" name="249" href="#249">249</a>                 <strong class="jxr_keyword">this</strong>.buffer.position(off + len);
<a class="jxr_linenumber" name="250" href="#250">250</a>             } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="251" href="#251">251</a>                 <strong class="jxr_keyword">while</strong> (<strong class="jxr_keyword">this</strong>.buffer.hasRemaining()) {
<a class="jxr_linenumber" name="252" href="#252">252</a>                     linebuffer.append((<strong class="jxr_keyword">char</strong>) (<strong class="jxr_keyword">this</strong>.buffer.get() &amp; 0xff));
<a class="jxr_linenumber" name="253" href="#253">253</a>                 }
<a class="jxr_linenumber" name="254" href="#254">254</a>             }
<a class="jxr_linenumber" name="255" href="#255">255</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="256" href="#256">256</a>             <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.charbuffer == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="257" href="#257">257</a>                 <strong class="jxr_keyword">this</strong>.charbuffer = CharBuffer.allocate(<strong class="jxr_keyword">this</strong>.lineBuffersize);
<a class="jxr_linenumber" name="258" href="#258">258</a>             }
<a class="jxr_linenumber" name="259" href="#259">259</a>             <strong class="jxr_keyword">this</strong>.chardecoder.reset();
<a class="jxr_linenumber" name="260" href="#260">260</a> 
<a class="jxr_linenumber" name="261" href="#261">261</a>             <strong class="jxr_keyword">for</strong> (;;) {
<a class="jxr_linenumber" name="262" href="#262">262</a>                 CoderResult result = <strong class="jxr_keyword">this</strong>.chardecoder.decode(
<a class="jxr_linenumber" name="263" href="#263">263</a>                         <strong class="jxr_keyword">this</strong>.buffer,
<a class="jxr_linenumber" name="264" href="#264">264</a>                         <strong class="jxr_keyword">this</strong>.charbuffer,
<a class="jxr_linenumber" name="265" href="#265">265</a>                         <strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="266" href="#266">266</a>                 <strong class="jxr_keyword">if</strong> (result.isError()) {
<a class="jxr_linenumber" name="267" href="#267">267</a>                     result.throwException();
<a class="jxr_linenumber" name="268" href="#268">268</a>                 }
<a class="jxr_linenumber" name="269" href="#269">269</a>                 <strong class="jxr_keyword">if</strong> (result.isOverflow()) {
<a class="jxr_linenumber" name="270" href="#270">270</a>                     <strong class="jxr_keyword">this</strong>.charbuffer.flip();
<a class="jxr_linenumber" name="271" href="#271">271</a>                     linebuffer.append(
<a class="jxr_linenumber" name="272" href="#272">272</a>                             <strong class="jxr_keyword">this</strong>.charbuffer.array(),
<a class="jxr_linenumber" name="273" href="#273">273</a>                             <strong class="jxr_keyword">this</strong>.charbuffer.position(),
<a class="jxr_linenumber" name="274" href="#274">274</a>                             <strong class="jxr_keyword">this</strong>.charbuffer.remaining());
<a class="jxr_linenumber" name="275" href="#275">275</a>                     <strong class="jxr_keyword">this</strong>.charbuffer.clear();
<a class="jxr_linenumber" name="276" href="#276">276</a>                 }
<a class="jxr_linenumber" name="277" href="#277">277</a>                 <strong class="jxr_keyword">if</strong> (result.isUnderflow()) {
<a class="jxr_linenumber" name="278" href="#278">278</a>                     <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="279" href="#279">279</a>                 }
<a class="jxr_linenumber" name="280" href="#280">280</a>             }
<a class="jxr_linenumber" name="281" href="#281">281</a> 
<a class="jxr_linenumber" name="282" href="#282">282</a>             <em class="jxr_comment">// flush the decoder</em>
<a class="jxr_linenumber" name="283" href="#283">283</a>             <strong class="jxr_keyword">this</strong>.chardecoder.flush(<strong class="jxr_keyword">this</strong>.charbuffer);
<a class="jxr_linenumber" name="284" href="#284">284</a>             <strong class="jxr_keyword">this</strong>.charbuffer.flip();
<a class="jxr_linenumber" name="285" href="#285">285</a>             <em class="jxr_comment">// append the decoded content to the line buffer</em>
<a class="jxr_linenumber" name="286" href="#286">286</a>             <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.charbuffer.hasRemaining()) {
<a class="jxr_linenumber" name="287" href="#287">287</a>                 linebuffer.append(
<a class="jxr_linenumber" name="288" href="#288">288</a>                         <strong class="jxr_keyword">this</strong>.charbuffer.array(),
<a class="jxr_linenumber" name="289" href="#289">289</a>                         <strong class="jxr_keyword">this</strong>.charbuffer.position(),
<a class="jxr_linenumber" name="290" href="#290">290</a>                         <strong class="jxr_keyword">this</strong>.charbuffer.remaining());
<a class="jxr_linenumber" name="291" href="#291">291</a>             }
<a class="jxr_linenumber" name="292" href="#292">292</a> 
<a class="jxr_linenumber" name="293" href="#293">293</a>         }
<a class="jxr_linenumber" name="294" href="#294">294</a>         <strong class="jxr_keyword">this</strong>.buffer.limit(origLimit);
<a class="jxr_linenumber" name="295" href="#295">295</a> 
<a class="jxr_linenumber" name="296" href="#296">296</a>         <em class="jxr_comment">// discard LF if found</em>
<a class="jxr_linenumber" name="297" href="#297">297</a>         <strong class="jxr_keyword">int</strong> l = linebuffer.length();
<a class="jxr_linenumber" name="298" href="#298">298</a>         <strong class="jxr_keyword">if</strong> (l &gt; 0) {
<a class="jxr_linenumber" name="299" href="#299">299</a>             <strong class="jxr_keyword">if</strong> (linebuffer.charAt(l - 1) == HTTP.LF) {
<a class="jxr_linenumber" name="300" href="#300">300</a>                 l--;
<a class="jxr_linenumber" name="301" href="#301">301</a>                 linebuffer.setLength(l);
<a class="jxr_linenumber" name="302" href="#302">302</a>             }
<a class="jxr_linenumber" name="303" href="#303">303</a>             <em class="jxr_comment">// discard CR if found</em>
<a class="jxr_linenumber" name="304" href="#304">304</a>             <strong class="jxr_keyword">if</strong> (l &gt; 0) {
<a class="jxr_linenumber" name="305" href="#305">305</a>                 <strong class="jxr_keyword">if</strong> (linebuffer.charAt(l - 1) == HTTP.CR) {
<a class="jxr_linenumber" name="306" href="#306">306</a>                     l--;
<a class="jxr_linenumber" name="307" href="#307">307</a>                     linebuffer.setLength(l);
<a class="jxr_linenumber" name="308" href="#308">308</a>                 }
<a class="jxr_linenumber" name="309" href="#309">309</a>             }
<a class="jxr_linenumber" name="310" href="#310">310</a>         }
<a class="jxr_linenumber" name="311" href="#311">311</a>         <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="312" href="#312">312</a>     }
<a class="jxr_linenumber" name="313" href="#313">313</a> 
<a class="jxr_linenumber" name="314" href="#314">314</a>     <strong class="jxr_keyword">public</strong> String readLine(<strong class="jxr_keyword">boolean</strong> endOfStream) <strong class="jxr_keyword">throws</strong> CharacterCodingException {
<a class="jxr_linenumber" name="315" href="#315">315</a>         CharArrayBuffer charbuffer = <strong class="jxr_keyword">new</strong> CharArrayBuffer(64);
<a class="jxr_linenumber" name="316" href="#316">316</a>         <strong class="jxr_keyword">boolean</strong> found = readLine(charbuffer, endOfStream);
<a class="jxr_linenumber" name="317" href="#317">317</a>         <strong class="jxr_keyword">if</strong> (found) {
<a class="jxr_linenumber" name="318" href="#318">318</a>             <strong class="jxr_keyword">return</strong> charbuffer.toString();
<a class="jxr_linenumber" name="319" href="#319">319</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="320" href="#320">320</a>             <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="321" href="#321">321</a>         }
<a class="jxr_linenumber" name="322" href="#322">322</a>     }
<a class="jxr_linenumber" name="323" href="#323">323</a> 
<a class="jxr_linenumber" name="324" href="#324">324</a> }
</pre>
<hr/><div id="footer">This page was automatically generated by <a href="http://maven.apache.org/">Maven</a></div></body>
</html>

